GtkWidget *Make_Browse(void)
{
	GtkTreeStore *Browse_Store;
	GtkTreeViewColumn *Column;
	GtkCellRenderer *Render;
	GtkTreeIter Iterator;
	GtkWidget *Browser;

	Browse_Store = gtk_tree_store_new(5, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_ULONG, G_TYPE_STRING, G_TYPE_UINT);

	Browser = gtk_scrolled_window_new(NULL, NULL);
	gtk_container_set_border_width(GTK_CONTAINER(Browser), 2);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(Browser), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	Browse_Tree = gtk_tree_view_new();
	gtk_tree_view_set_enable_search(GTK_TREE_VIEW(Browse_Tree), FALSE);
	g_signal_connect(Browse_Tree, "button-press-event", G_CALLBACK(Call_Mouse_Event), "Browser");
	gtk_container_add(GTK_CONTAINER(Browser), Browse_Tree);
	
	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Name");
	gtk_tree_view_column_set_expand(GTK_TREE_VIEW_COLUMN(Column), TRUE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(Browse_Tree), Column);
	
	Render = gtk_cell_renderer_pixbuf_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "stock-id", 0);
	
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 1);
	
	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Size");
	gtk_tree_view_append_column(GTK_TREE_VIEW(Browse_Tree), Column);
	
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 2);

	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Path");
	gtk_tree_view_column_set_expand(GTK_TREE_VIEW_COLUMN(Column), TRUE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(Browse_Tree), Column);
	
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 3);
	
	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Type");
	gtk_tree_view_append_column(GTK_TREE_VIEW(Browse_Tree), Column);
	
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 4);
	gtk_tree_view_column_set_visible(Column, FALSE);

	gtk_tree_view_set_model(GTK_TREE_VIEW(Browse_Tree), GTK_TREE_MODEL(Browse_Store));

	gtk_tree_store_append(Browse_Store, &Iterator, NULL);
	gtk_tree_store_set(Browse_Store, &Iterator, 0, Browse_Icon[0], 1, "Network", 3, "smb://", -1);

	return Browser;
}

GtkWidget *Make_Search(void)
{
	GtkListStore *Search_Store;
	GtkTreeViewColumn *Column;
	GtkCellRenderer *Render;
	GtkWidget *Scroller;
	GtkWidget *VBox;
	GtkWidget *HBox;

	Search_Store = gtk_list_store_new(5, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_ULONG, G_TYPE_STRING, G_TYPE_UINT);
	
	VBox = gtk_vbox_new(FALSE, 2);
	gtk_container_set_border_width(GTK_CONTAINER(VBox), 2);
	
	HBox = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);
	
	Selecter = gtk_combo_box_new_text();
	gtk_box_pack_start(GTK_BOX(HBox), Selecter, TRUE, TRUE, 0);
	
	Search_Find_Button = gtk_button_new_from_stock(GTK_STOCK_FIND);
	g_signal_connect(Search_Find_Button, "clicked", G_CALLBACK(Start_Search), Search_Store);	
	gtk_box_pack_start(GTK_BOX(HBox), Search_Find_Button, FALSE, FALSE, 0);

	Search_Stop_Button = gtk_button_new_from_stock(GTK_STOCK_STOP);
	g_signal_connect(Search_Stop_Button, "clicked", G_CALLBACK(Stop_Search), NULL);
	gtk_box_pack_start(GTK_BOX(HBox), Search_Stop_Button, FALSE, FALSE, 0);

	Search_Clear_Button = gtk_button_new_from_stock(GTK_STOCK_CLEAR);
	g_signal_connect(Search_Clear_Button, "clicked", G_CALLBACK(Clear_List), Search_Store);	
	gtk_box_pack_start(GTK_BOX(HBox), Search_Clear_Button, FALSE, FALSE, 0);
	
	Scroller = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(Scroller), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_box_pack_start(GTK_BOX(VBox), Scroller, TRUE, TRUE, 0);	
	
	Search_List = gtk_tree_view_new();
	gtk_tree_view_set_search_column(GTK_TREE_VIEW(Search_List), 1);
	gtk_tree_view_set_enable_search(GTK_TREE_VIEW(Search_List), TRUE);
	g_signal_connect(Search_List, "button-press-event", G_CALLBACK(Call_Mouse_Event), "Seacher");
	gtk_container_add(GTK_CONTAINER(Scroller), Search_List);

	Column = gtk_tree_view_column_new();
	gtk_tree_view_append_column(GTK_TREE_VIEW(Search_List), Column);
	Render = gtk_cell_renderer_pixbuf_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "stock-id", 0);
	
	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Name");
	gtk_tree_view_column_set_expand(GTK_TREE_VIEW_COLUMN(Column), TRUE);
	gtk_tree_view_column_set_sort_column_id(Column, 1);
	gtk_tree_view_append_column(GTK_TREE_VIEW(Search_List), Column);
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 1);
	
	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Size");
	gtk_tree_view_column_set_sort_column_id(Column, 2);
	gtk_tree_view_append_column(GTK_TREE_VIEW(Search_List), Column);
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 2);

	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Path");
	gtk_tree_view_column_set_expand(GTK_TREE_VIEW_COLUMN(Column), TRUE);
	gtk_tree_view_column_set_sort_column_id(Column, 3);
	gtk_tree_view_append_column(GTK_TREE_VIEW(Search_List), Column);
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 3);
	
	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Type");
	gtk_tree_view_append_column(GTK_TREE_VIEW(Search_List), Column);
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 4);
	gtk_tree_view_column_set_visible(Column, FALSE);

	gtk_tree_view_set_model(GTK_TREE_VIEW(Search_List), GTK_TREE_MODEL(Search_Store));

	return VBox;
}

GtkWidget *Make_Download(void)
{
	GtkTreeStore *Download_Store;
	GtkTreeViewColumn *Column;
	GtkCellRenderer *Render;
	GtkWidget *Scroller;
	GtkWidget *VBox;	
	GtkWidget *HBox;

	Download_Store = gtk_tree_store_new(6, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_STRING, G_TYPE_ULONG, G_TYPE_UINT);

	VBox = gtk_vbox_new(FALSE, 2);
	gtk_container_set_border_width(GTK_CONTAINER(VBox), 2);
	
	Scroller = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(Scroller), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_box_pack_start(GTK_BOX(VBox), Scroller, TRUE, TRUE, 0);	

	Download_Tree = gtk_tree_view_new();
	gtk_tree_view_set_enable_search(GTK_TREE_VIEW(Download_Tree), FALSE);
	g_signal_connect(Download_Tree, "button-press-event", G_CALLBACK(Call_Mouse_Event), "Downloader");
	gtk_container_add(GTK_CONTAINER(Scroller), Download_Tree);	
	
	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Status");
	gtk_tree_view_append_column(GTK_TREE_VIEW(Download_Tree), Column);
	
	Render = gtk_cell_renderer_pixbuf_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "stock-id", 0);
	
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 1);

	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Progress");
	gtk_tree_view_append_column(GTK_TREE_VIEW(Download_Tree), Column);
	
	Render = gtk_cell_renderer_progress_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "value", 2);

	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Full path");
	gtk_tree_view_column_set_expand(GTK_TREE_VIEW_COLUMN(Column), TRUE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(Download_Tree), Column);
	
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 3);
	
	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Size");
	gtk_tree_view_append_column(GTK_TREE_VIEW(Download_Tree), Column);
	
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 4);
	
	Column = gtk_tree_view_column_new();
	gtk_tree_view_column_set_title(Column, "Type");
	gtk_tree_view_append_column(GTK_TREE_VIEW(Download_Tree), Column);
	
	Render = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(Column, Render, FALSE);
	gtk_tree_view_column_add_attribute(Column, Render, "text", 5);
	gtk_tree_view_column_set_visible(Column, FALSE);
	
	gtk_tree_view_set_model(GTK_TREE_VIEW(Download_Tree), GTK_TREE_MODEL(Download_Store));

	HBox = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(VBox), HBox, FALSE, FALSE, 0);

	Download_Clear_Button = gtk_button_new_from_stock(GTK_STOCK_CLEAR);
	g_signal_connect(Download_Clear_Button, "clicked", G_CALLBACK(Clear_Tree), NULL);
	gtk_box_pack_end(GTK_BOX(HBox), Download_Clear_Button, FALSE, FALSE, 0);

	Download_Stop_Button = gtk_button_new_from_stock(GTK_STOCK_STOP);
	g_signal_connect(Download_Stop_Button, "clicked", G_CALLBACK(Stop_Download), NULL);	
	gtk_box_pack_end(GTK_BOX(HBox), Download_Stop_Button, FALSE, FALSE, 0);

	Download_Save_Button = gtk_button_new_from_stock(GTK_STOCK_SAVE);
	g_signal_connect(Download_Save_Button, "clicked", G_CALLBACK(Start_Download), NULL);
	gtk_box_pack_end(GTK_BOX(HBox), Download_Save_Button, FALSE, FALSE, 0);

	return VBox;
}
